/*
File name: nuance_ecom.js
Author:   Audrey White
Description: Based on namespace nuance_form. Must be loaded AFTER nuance.js
Change history: 
06/24/2015/AWHITE: adding data for EMEA - e-commerce dynamic programID code
06/29/2015/AWHITE: completing logic before testing
06/30/2015/AWHITE: adding default data value,fixing capitolization and medium vs media
07/02/2015/AWHITE: adding querystring per BU request
08/04/2015/AWHITE: adding session cookie to capture utm_medium and use across the site. 
*/

//global variables
var versionNumber = '0.1.05';
var utm_media = "";

$(document).ready(function() {
	verbose("Verbose mode is on for nuance_ecom.js / version: " + versionNumber);	
	replace_PGMID();
});
  
function replace_PGMID() {
	var currentURL = document.URL;
	var nuance_ecom_utm_media = n_getCookies("nuance_ecom_utm_media");
	var cookieUtmMedia = (nuance_ecom_utm_media !="" && nuance_ecom_utm_media != null);
	verbose("cookieUtmMedia:" + cookieUtmMedia);
  if ((currentURL.indexOf("utm_medium") != -1) || cookieUtmMedia) { //utm-media present, proceed
	var pgmID_URL = "";
	var incoming_QueryString = "";
	var pgmID = "";
	var pgmID_Start = 0; 
	var pgmID_replacement = "";
 	var utm_media = urlParam("utm_medium");
 	
 	//assign top level session cookie with utm_media
 	if(cookieUtmMedia){
 		utm_media = nuance_ecom_utm_media;
	}else{
		  	 	$.cookie('nuance_ecom_utm_media', utm_media, { expires: 90, path: '/' });
	}
		verbose("cookieUtmMedia after:" + n_getCookies("nuance_ecom_utm_media"));
	
	// load ecom data
	var utmMediaData = {
	"emea_affiliate": "95691300",
	"emea_cpc": "95691400",
	"emea_email": "95691500",
	"emea_pipeline": "95691600",
	"emea_callcentre": "95691700",
	"emea_partners": "95691800",
	"emea_refer_a_friend": "95691900",
	"emea_referral": "95692000",
	"emea_display": "95692000",
	"emea_retargeting": "95692000",
	"emea_trial": "95692100",
	"emea_social": "95692200",
	"emea_default": "94913000"
	};
  	
  	//dashes make javascript object arrays unhappy, remove.
  	utmMedia= utm_media.toLowerCase().replace("-","_");
  	
  	//is this a name in the utmMediaData Array?
  	verbose(utmMedia + " in utmMediaData? value = "+ (utmMedia in utmMediaData)+" value = " +utmMediaData[utmMedia]);
  	if(utmMedia in utmMediaData){
    	pgmID_replacement = utmMediaData[utmMedia];
    }else {
    	pgmID_replacement = utmMediaData["emea_default"]; //value for blank or unrecognizeable
    }
    verbose("pgmID_replacement = " + pgmID_replacement);
  
  	//search all links with pgmid in them and replace with appropriate pgmid based on utm_media
  	$("a[href*='/pgm.']").each(function(index) {
  		pgmID_URL = $(this).attr('href');
  		//verbose("pgmID_URL = " + pgmID_URL);
  		pgmID_Start = pgmID_URL.indexOf("/pgm.") + 5;
  		incoming_QueryString = currentURL.substring(currentURL.indexOf("?"));
  		pgmID = pgmID_URL.substring(pgmID_Start, (pgmID_Start + 8));// presumes pgmID will always be 8 characters
  		//verbose("incoming_QueryString = "  + incoming_QueryString);
    	$(this).attr('href', pgmID_URL.replace(pgmID, pgmID_replacement) + incoming_QueryString);
  		//verbose("updated pgmID_URL = " + $(this).attr('href'));
  	});
  	
  }//end of test to see if utm_media is even present in URL
  
}//end function replace_PGMID() 


